"""
Very simple calculator

using pyparsing
"""

from pyparsing import oneOf, Word, nums, operatorPrecedence, opAssoc

def sign(token):
    if token[0][0] == '-':
        return -token[0][1]
    else:
        return token[0][1]

def arithOp(token):
    result = token[0][0]
    for j in range(1,len(token[0]),2):
        op = token[0][j]
        if op == '+':
            result += token[0][j+1]
        elif op == '-':
            result -= token[0][j+1]
        elif op == '*':
            result *= token[0][j+1]
        elif op == '/':
            result /= token[0][j+1]
    return result

number = Word(nums).setParseAction(lambda t: int(t[0]))

signop = oneOf('+ -')
plusop = oneOf('+ -')
multop = oneOf('* /')

expr = operatorPrecedence( number,
      [(signop, 1, opAssoc.RIGHT, sign),
       (multop, 2, opAssoc.LEFT, arithOp),
       (plusop, 2, opAssoc.LEFT, arithOp),] 
      )

test = ["9 + 2 + 3",
      "9 + 2 *3",
      "-9 + 2 * 3",
      "(-9 + 2) * 3",
      "(-9 +2 +3 + 4) - (2 * 3 * 4)",
      ]

for t in test:
   print t, expr.parseString(t)


